﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace szalloda
{
    class Foglalas
    {
        public int ID { get; set; }
        public int Szoba { get; set; }
        public int Kezd { get; set; }
        public int Veg { get; set; }
        public int Fo { get; set; }
        public int Kaja { get; set; }
        public string Nev { get; set; }
        public int Ár()
        {
            int ár = Fo * Kaja * 1100;
            ár += (Fo == 3) ? 2000 : 0;
            int szobaár = 0;
            if (Kezd <121)
            {
                szobaár = 9000;
            }
            else if (Kezd < 244)
            {
                szobaár = 10000;
            }
            else
            {
                szobaár = 8000;
            }
            ár += szobaár;
            ár *= (Veg - Kezd);
            return ár;
        }

        public Foglalas(string[] adat)
        {
            ID = int.Parse(adat[0]);
            Szoba = int.Parse(adat[1]);
            Kezd = int.Parse(adat[2]);
            Veg = int.Parse(adat[3]);
            Fo = int.Parse(adat[4]);
            Kaja = int.Parse(adat[5]);
            Nev = adat[6];
        }

    }


    public struct Honap
    {
        public string month;
        public int length;
        public int first;
    }

    class Program
    {

        static void Main(string[] args)
        {
            List<Foglalas> Forgalom = new List<Foglalas>();


            #region 1. feladat
            StreamReader sr = new StreamReader("honapok.txt");
            Honap[] Ev = new Honap[13];
            for (int i = 1; i < 13; i++)
            {
                Ev[i] = new Honap();
                Ev[i].month = sr.ReadLine();
                Ev[i].length = int.Parse(sr.ReadLine());
                Ev[i].first = int.Parse(sr.ReadLine());
            }
            sr.Close();
            sr = new StreamReader("pitypang.txt");
            int N = int.Parse(sr.ReadLine());
            for (int i = 0; i < N; i++)
            {
                Forgalom.Add(new Foglalas(sr.ReadLine().Split(' ')));
            }
            sr.Close();
            #endregion
            #region 2. feladat
            int max = 0;
            foreach (Foglalas f in Forgalom)
            {
                if (f.Veg-f.Kezd > Forgalom[max].Veg-Forgalom[max].Kezd)
                {
                    max = f.ID - 1;
                }
            }
            Console.WriteLine("2. feladat");
            Console.WriteLine("{0} ({1}) - {2}", Forgalom[max].Nev, Forgalom[max].Kezd, Forgalom[max].Veg - Forgalom[max].Kezd);
            #endregion
            #region 3. feladat
            int szum = 0;
            StreamWriter sw = new StreamWriter("bevetel.txt");
            foreach (Foglalas f in Forgalom)
            {
                szum += f.Ár();
                sw.WriteLine("{0}:{1}", f.ID, f.Ár());
            }
            sw.Close();
            Console.WriteLine("\n3. feladat");
            Console.WriteLine("{0:C0} az összbevétel", szum);
            #endregion
            #region 4. feladat
            int[] létszám = new int[366];
            for (int i = 1; i < 366; i++)
            {
                létszám[i] = 0;
            }
            foreach (Foglalas f in Forgalom)
            {
                for (int j = f.Kezd; j < f.Veg; j++)
                {
                    létszám[j] += f.Fo;
                }
            }
            Console.WriteLine("\n4. feladat");
            for (int i = 1; i < 13; i++)
            {
                int vendégéj = 0;
                for (int j = 0; j < Ev[i].length; j++)
                {
                    vendégéj += létszám[Ev[i].first + j];
                }
                Console.WriteLine("{0}: {1} vendégéj", i, vendégéj);
            }
            #endregion
            #region 5. feladat
            Console.WriteLine("\n5. feladat");
            Console.Write("Adja meg a foglalás kezdőnapjának sorszámát! (1<= sorszám <=365):");
            int eleje = int.Parse(Console.ReadLine());
            Console.Write("Adja meg az eltöltendő éjszakák számát:");
            int hossz = int.Parse(Console.ReadLine());
            bool[] szabad = new bool[28];
            for (int i = 1; i < 28; i++)
            {
                szabad[i] = true;
            }
            foreach (Foglalas f in Forgalom)
            {
                if (f.Kezd< eleje+hossz && f.Veg > eleje)
                {
                    szabad[f.Szoba] = false;
                }
            }
            int db = 0;
            for (int i = 1; i < 28; i++)
            {
                if (szabad[i] == true)
                {
                    db++;  
                }
            }
            Console.WriteLine(db+" szoba szabad");
            #endregion
            Console.ReadLine();
        }
    }
}
